"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Block = function Block(_ref) {
  var css = _ref.css,
      children = _ref.children,
      fullHeight = _ref.fullHeight,
      gray = _ref.gray,
      largePadding = _ref.largePadding,
      noPadding = _ref.noPadding,
      styles = _ref.styles;
  return _react.default.createElement("div", css(styles.container, fullHeight && styles.fullHeight, gray && styles.container_gray, largePadding && styles.largePadding, noPadding && styles.noPadding), children);
};

var BlockWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius;
  return {
    container: {
      background: color.white,
      borderRadius: radius,
      padding: units(1)
    },
    noPadding: {
      padding: 0
    },
    largePadding: {
      padding: units(1)
    },
    container_gray: {
      background: color.grayLight
    },
    fullHeight: {
      height: '100%'
    }
  };
})(Block);
var _default = BlockWithStyles;
exports.default = _default;