import React from 'react'
import { Link } from 'react-router-dom'
import { withStyles } from '../helpers/withStyles'

const Anchor = (
    {
        block,
        children,
        disabled,
        href,
        loading,
        openInNewWindow,
        css,
        theme,
        styles,
        noHoverUnderline,
        ...props
    }

) => (
    href ?
        <Link
            {...props}
            {...css(styles.anchor, !noHoverUnderline && styles.anchor_underlined)}
            to={href}
            disabled={disabled}
            target={openInNewWindow ? '_blank' : '_self'}
        >
            { children }
        </Link>
    :
        <a
            {...props}
            {...css(styles.anchor, !noHoverUnderline && styles.anchor_underlined)}
        >
            { children }
        </a>
);

const AnchorWithStyles = withStyles(({ color }) => ({
    anchor: {
        color: color.secondary,
        cursor: 'pointer'
    },

    anchor_underlined: {
        ':hover': {
            textDecoration: 'underline'
        }
    }
}))(Anchor);

export default AnchorWithStyles

