import React from 'react'
import { withStyles } from '../helpers/withStyles'

const Block = ({
    css,
    children,
    fullHeight,
    gray,
    largePadding,
    noPadding,
    styles
}) => {
    return (
        <div
            {...css(
                styles.container,
                fullHeight && styles.fullHeight,
                gray && styles.container_gray,
                largePadding && styles.largePadding,
                noPadding && styles.noPadding
            )}
        >
            { children }
        </div>
    )
}

const BlockWithStyles = withStyles(({ color, units, radius }) => ({
    container: {
        background: color.white,
        borderRadius: radius,
        padding: units(1)
    },

    noPadding: {
        padding: 0,
    },

    largePadding: {
        padding: units(1)
    },

    container_gray: {
        background: color.grayLight
    },

    fullHeight: {
        height: '100%'
    }

}))(Block)

export default BlockWithStyles
