import React, { Component, Fragment } from 'react'
import { Circle as GoogleMapCircle, Marker } from 'react-google-maps'

const defaultProps = {
    center: { lat: -19.9322014, lng: -43.9246216 },
    radius: 50,
    options: {
        fillColor: '#ee430e',
        strokeColor: '#ee430e',
        strokeWeight: 1,
        fillOpacity: .3,
        strokeOpacity: .5
    }
};

class MapCircle extends Component {
    render() {
        const { center, draggable, editable, onCenterChanged, onDragEnd, onRadiusChanged, options, radius } = this.props

        return (
            <Fragment>
                <GoogleMapCircle
                    ref={circle => this.circle = circle}
                    center={center}
                    radius={radius}
                    options={options}
                    draggable={draggable}
                    editable={editable}
                    onCenterChanged={() => this.circle && onCenterChanged && onCenterChanged(this.circle.getCenter())}
                    onDragEnd={() => this.circle && onDragEnd && onDragEnd(this.circle.getCenter())}
                    onRadiusChanged={() => this.circle && onRadiusChanged && onRadiusChanged(this.circle.getRadius())}
                />
                <Marker position={center} visible={false}/>
            </Fragment>
        )
    }
}

MapCircle.defaultProps = defaultProps;

export default MapCircle
