import React, { Component, Fragment } from 'react'
import { Polygon, Marker } from 'react-google-maps'

const defaultProps = {
    path: [{ lat: -19.9322014, lng: -43.9246216 }],
    options: { fillColor:'#ee430e', strokeColor: '#ee430e', strokeWeight: 1, fillOpacity: .3, strokeOpacity: .5 }
};

class MapPolygon extends Component {
    render() {
        const { draggable, editable, path, onEdit, options } = this.props;

        return (
            <Fragment>
                <Polygon
                    draggable={draggable}
                    editable={editable}
                    ref={polygon => this.polygon = polygon}
                    path={path}
                    onMouseUp={() => this.polygon && onEdit && onEdit(this.polygon.getPath())}
                    options={options}
                />
                <Marker position={path[0]} visible={false} />
            </Fragment>
        )
    }
}

MapPolygon.defaultProps = defaultProps;

export default MapPolygon
