import { Route } from 'react-router-dom'
import { connect } from  'react-redux'
import React, { Component } from 'react'

class PrivateRoute extends Component {
    handleUnauthorizedAccess() {
        console.log(window.location)
        const { href } = window.location;
        return <Route render={() => window.location = `http://auth.localcinnecta.com/signin?continue=${href}`} />
    }

    render() {
        const { component: Component, render, authenticated, loading, location, ...rest } = this.props;

        if(loading) {
            return <Route {...rest} component={Loading} />
        }
        let renderMethod = render;
        if (render && !authenticated) {
            renderMethod = () => this.handleUnauthorizedAccess(location)
        }
        return (
            <Route
                {...rest}
                render={
                    render ? renderMethod
                    : props =>
                        authenticated ? <Component {...props} />
                        : this.handleUnauthorizedAccess(location)
                }
            />
        )
    }
}

const Loading = () => (
    <div>Autenticando...</div>
);

const mapStateToProps = state => {
    const { authenticated, loading } = state.auth;
    return { authenticated, loading }
};

const ConnectedPrivateRoute = connect(mapStateToProps)(PrivateRoute);
export { ConnectedPrivateRoute as PrivateRoute }
