import React from 'react'
import { withStyles } from '../helpers/withStyles'

const Tag = (
    {
        children,
        css,
        label,
        styles
    }
) => (
    <div
        {...css(
            styles.tag
        )}
    >
        { children || label }
    </div>
);

const TagWithStyles = withStyles(({ color, units, font, fontSize, radius, breakpoint }) => ({
    tag: {
        appearance: 'none',
        borderWidth: 0,
        background: color.blueGrayLighter,
        display: 'inline-block',
        paddingTop: 5,
        paddingRight: 8,
        paddingBottom: 5,
        paddingLeft: 8,
        borderRadius: radius,
        fontSize: fontSize.small.small,
        color: color.blueGrayDark,
        outline: 0,
        position: 'relative',
        marginLeft: units(0.125),
        marginRight: units(0.125),
        marginBottom: units(0.5),
        fontWeight: 500,
        lineHeight: 1,
        fontFamily: font.default,
        boxSizing: 'border-box',
        overflow: 'hidden',
        whiteSpace: 'nowrap',

        [breakpoint.large]: {
            fontSize: fontSize.large.small
        }
    },

    tag_soft: {
        background: color.blueGrayLighter,
        color: color.primary,
    },

    tag_mono: {
        background: color.transparent,
        borderColor: color.black,
        borderWidth: 1,
        borderStyle: 'solid',
        color: color.black,
    },

    tag_primary: {
        background: color.primary,
    },

    tag_secondary: {
        background: color.transparent,
        borderColor: color.secondary,
        borderWidth: 1,
        borderStyle: 'solid',
        color: color.secondary,
    },

    tag_inverse: {
        background: color.white,
        color: color.primary,
        borderWidth: 0,
    },

    tag_outline: {

    }
}))(Tag);

export default TagWithStyles
